"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.lazyWithPreload = lazyWithPreload;
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function lazyWithPreload(factory) {
  const ReactLazyComponent = /*#__PURE__*/React.lazy(factory);
  let PreloadedComponent;
  let factoryPromise;
  const Component = /*#__PURE__*/React.forwardRef(function LazyWithPreload(props, ref) {
    // Once one of these is chosen, we must ensure that it continues to be
    // used for all subsequent renders, otherwise it can cause the
    // underlying component to be unmounted and remounted.
    const ComponentToRender = React.useRef(PreloadedComponent ?? ReactLazyComponent);
    return /*#__PURE__*/React.createElement(ComponentToRender.current, Object.assign(ref ? {
      ref
    } : {}, props));
  });
  const LazyWithPreload = Component;
  LazyWithPreload.preload = () => {
    if (!factoryPromise) {
      factoryPromise = factory().then(module => {
        PreloadedComponent = module.default;
        return PreloadedComponent;
      });
    }
    return factoryPromise;
  };
  return LazyWithPreload;
}
var _default = lazyWithPreload;
exports.default = _default;
//# sourceMappingURL=lazy.js.map