"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useBottomTabBadges;
var React = _interopRequireWildcard(require("react"));
var _BottomTabBadgesContext = _interopRequireDefault(require("./contexts/BottomTabBadgesContext"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function useBottomTabBadges() {
  const {
    setBadge,
    badges,
    setMultipleBadges
  } = React.useContext(_BottomTabBadgesContext.default);
  const updateBadge = React.useCallback((tab, badge) => {
    setBadge(tab.path, badge);
  }, [setBadge]);
  const updateBadges = React.useCallback(multipleBadges => {
    const newBadges = {};
    multipleBadges.forEach(_ref => {
      let {
        tab,
        badge
      } = _ref;
      newBadges[tab.path] = badge;
    });
    setMultipleBadges(newBadges);
  }, [setMultipleBadges]);
  return {
    badges,
    updateBadge,
    updateBadges
  };
}
//# sourceMappingURL=useBottomTabBadges.js.map