"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useDeepLinkingBottomTabsIndex;
var React = _interopRequireWildcard(require("react"));
var _useNavigation = _interopRequireDefault(require("./useNavigation"));
var _OptimizedContext = _interopRequireDefault(require("./contexts/OptimizedContext"));
var _useCurrentRoot = _interopRequireDefault(require("./useCurrentRoot"));
var _navigationUtils = require("./navigationUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function useDeepLinkingBottomTabsIndex() {
  const {
    push
  } = (0, _useNavigation.default)();
  const {
    currentRoot
  } = (0, _useCurrentRoot.default)();
  const {
    stateNavigator
  } = React.useContext(_OptimizedContext.default);

  // eslint-disable-next-line react-hooks/exhaustive-deps
  const children = (currentRoot === null || currentRoot === void 0 ? void 0 : currentRoot.type) === 'bottomTabs' ? currentRoot.children : [];
  const stateKey = stateNavigator.stateContext.state.key;
  const currentTabKey = (0, _navigationUtils.getBottomTabKeyFromPath)(stateKey);
  const bottomTabIndex = children.findIndex(child => child.path === '/' + currentTabKey) || 0;
  const setBottomTabIndex = React.useCallback(index => {
    var _children$index;
    const tab = children === null || children === void 0 ? void 0 : children[index];
    const screen = children === null || children === void 0 ? void 0 : (_children$index = children[index]) === null || _children$index === void 0 ? void 0 : _children$index.child;
    if (screen) {
      push(screen, {}, {
        preload: true,
        toBottomTab: tab
      });
    }
  }, [children, push]);
  return React.useMemo(() => ({
    bottomTabIndex,
    setBottomTabIndex
  }), [bottomTabIndex, setBottomTabIndex]);
}
//# sourceMappingURL=useDeepLinkingBottomTabsIndex.web.js.map