"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useNavigationUrl = useNavigationUrl;
var _useUrl = _interopRequireDefault(require("./useUrl"));
var React = _interopRequireWildcard(require("react"));
var _navigationUtils = require("./navigationUtils");
var _reactNative = require("react-native");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function withoutBasePath(url, basePath) {
  if (!url) {
    return undefined;
  }
  return basePath ? url.replace(`/${basePath}`, '') : url;
}
function useNavigationUrl(_ref) {
  let {
    navigationRoot,
    initialRootKey,
    basePath
  } = _ref;
  const cachedInitialRootKey = React.useRef(initialRootKey);
  const initialDefaultUrl = React.useMemo(() => {
    const defaultRootKey = cachedInitialRootKey.current || Object.keys(navigationRoot)[0];
    const defaultRoot = navigationRoot[defaultRootKey];
    return '/' + getPathFromRoot(defaultRoot, undefined, defaultRootKey);
  }, [navigationRoot]);
  const initialUrl = (0, _useUrl.default)() || initialDefaultUrl;
  const [goToUrl, setGoToUrl] = React.useState(initialUrl);
  React.useEffect(() => {
    setGoToUrl(initialUrl);
  }, [initialUrl]);
  React.useEffect(() => {
    if (goToUrl) {
      // reset goToUrl after it has been handled, so we can handle new deep links
      // because in the meantime user can navigate away from goToUrl
      const timerId = setTimeout(() => {
        setGoToUrl(undefined);
      }, 1500);
      return () => {
        clearTimeout(timerId);
      };
    }
    return undefined;
  }, [goToUrl, setGoToUrl]);
  return {
    goToUrl: withoutBasePath(goToUrl, basePath),
    setGoToUrl,
    initialDefaultUrl: withoutBasePath(initialDefaultUrl, basePath)
  };
}
function getPathFromRoot(root, tab, rootKey) {
  if (root.type === 'bottomTabs') {
    return (0, _navigationUtils.getScreenKey)(rootKey, tab || root.children[0], _reactNative.Platform.OS === 'web' ? root.children[0].path : undefined);
  }
  return (0, _navigationUtils.getScreenKey)(rootKey, undefined, root.child.path);
}
//# sourceMappingURL=useNavigationUrl.js.map