"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useUrl;
var _url = require("./url");
var _expoLinking = require("expo-linking");
function useUrl() {
  const url = (0, _expoLinking.useURL)();
  if ((0, _url.isExpoUrl)(url)) {
    return null;
  }
  let finalUrl = url || _url.initialUrl;
  if (!finalUrl) {
    return null;
  }
  return removePrefix(finalUrl);
}
function removePrefix(str) {
  const parts = str.split('://');
  if (parts.length > 1) {
    return parts.slice(1).join('://');
  }
  return str;
}
//# sourceMappingURL=useUrl.js.map