"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _RidgeNavigationContext = _interopRequireDefault(require("../contexts/RidgeNavigationContext"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const defaultSize = 18;
function BottomTabBadgeWeb(_ref) {
  let {
    children,
    size = defaultSize,
    visible = true,
    aboveDrawerBreakingPoint,
    ...rest
  } = _ref;
  const {
    theme
  } = React.useContext(_RidgeNavigationContext.default);
  const backgroundColor = theme.bottomBar.badgeColor || 'red';
  const textColor = theme.bottomBar.badgeTextColor;
  const borderRadius = size / 2;
  if (!visible) {
    return null;
  }
  return /*#__PURE__*/React.createElement(_reactNative.Text, _extends({
    numberOfLines: 1,
    style: [styles.container, {
      opacity: 1,
      backgroundColor: aboveDrawerBreakingPoint ? undefined : backgroundColor,
      color: aboveDrawerBreakingPoint ? theme.bottomBar.textColor : textColor,
      fontSize: size * 0.7,
      lineHeight: size,
      height: size,
      fontWeight: '500',
      minWidth: size,
      borderRadius,
      fontFamily: theme.bottomBar.fontFamily
    }]
  }, rest), children);
}
const styles = _reactNative.StyleSheet.create({
  container: {
    alignSelf: 'flex-end',
    textAlign: 'center',
    textAlignVertical: 'center',
    paddingHorizontal: 4,
    overflow: 'hidden',
    fontFamily: '-apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol"'
  }
});
var _default = /*#__PURE__*/React.memo(BottomTabBadgeWeb);
exports.default = _default;
//# sourceMappingURL=BottomTabBadgeWeb.js.map