import * as React from 'react';
import RidgeNavigationContext from './RidgeNavigationContext';
import { NavigationContext } from 'navigation-react';
import { generatePath } from '../navigationUtils';
// TODO: this could be deprecated in favor of a useContextSelector :)
// We only want to render the screen once, not twice
const OptimizedContext = /*#__PURE__*/React.createContext({});
export function OptimizedContextProvider(_ref) {
  let {
    data,
    state,
    children,
    withSuspenseContainer = true
  } = _ref;
  const {
    preloadedCache,
    rootNavigator,
    preloadRoot,
    preloadScreen,
    preloadElement,
    theme,
    SuspenseContainer
  } = React.useContext(RidgeNavigationContext);
  const {
    stateNavigator,
    state: fallbackState,
    data: fallbackData
  } = React.useContext(NavigationContext);
  const preloadId = (state === null || state === void 0 ? void 0 : state.preloadId) || (fallbackState === null || fallbackState === void 0 ? void 0 : fallbackState.preloadId);
  const params = data || fallbackData;
  const value = React.useMemo(() => ({
    data: params,
    rootNavigator,
    stateNavigator,
    preloadRoot,
    preloadScreen,
    preloadElement,
    theme,
    preloaded: preloadedCache[generatePath(preloadId, params)]
  }), [params, rootNavigator, stateNavigator, preloadRoot, preloadScreen, preloadElement, theme, preloadedCache, preloadId]);
  return /*#__PURE__*/React.createElement(OptimizedContext.Provider, {
    value: value
  }, withSuspenseContainer ? /*#__PURE__*/React.createElement(SuspenseContainer, null, children) : /*#__PURE__*/React.createElement(React.Suspense, {
    fallback: null
  }, children));
}
export default OptimizedContext;
//# sourceMappingURL=OptimizedContext.js.map