import { BaseScreen, BottomTabType, ExtractRouteParams } from './navigationUtils';
type NavigateOptions = {
    preload?: boolean;
    toBottomTab?: BottomTabType;
};
export default function useNavigation(): {
    currentRootKey: string;
    currentRoot: import("./navigationUtils").RootValue | undefined;
    preloadElement: (screen: BaseScreen) => void;
    preloadRoot: (rootKey: string) => void;
    preload: <T extends BaseScreen>(screen: T, params: ExtractRouteParams<T["path"]>) => Promise<void>;
    pop: (dist?: number) => void;
    popToTop: () => void;
    switchRoot: (rootKey: string, preloadSetting?: boolean) => void;
    push: <T_1 extends BaseScreen>(screen: T_1, params: ExtractRouteParams<T_1["path"]>, options?: NavigateOptions) => void;
    replace: <T_2 extends BaseScreen>(screen: T_2, params: ExtractRouteParams<T_2["path"]>, options?: NavigateOptions) => void;
    refresh: <T_3 extends BaseScreen>(screen: T_3, params: ExtractRouteParams<T_3["path"]>, options?: NavigateOptions) => void;
    theme: import("./theme").Theme;
    canNavigateBack: (dist?: number) => boolean;
    fluent: (rootSettings: import("./navigationUtils").FluentParams, ...fluentScreens: import("./navigationUtils").FluentScreen[]) => void;
};
export {};
//# sourceMappingURL=useNavigation.d.ts.map